#!/bin/sh
scriptname=`basename $0`

exec 1>>/tmp/logs/${scriptname}.out
exec 2>>/tmp/logs/${scriptname}.out
# set -x # only for debug purpose

LOGFACILITY="daemon"

logmessage()
{
  msg="$1"
  logger -p ${LOGFACILITY}.notice -t "NET" "${scriptname}: ${msg}"
}

logmessage_warn()
{
    msg="$1"
    logger -p ${LOGFACILITY}.warning -t "NET" "${scriptname}: ${msg}"
}

CONF_DIR=/data/networking
CONF_DIR_TMP=/tmp/networking
tmpDhcpParameters=${CONF_DIR_TMP}/dhcpv4.${interface}.env.$$
pidfile=${CONF_DIR_TMP}/addressWatchDog.pid

# Import common definitions and functions
. /Opera_Deploy/networking/lib.sh

# Check if an instance is running
if [ -f ${pidfile} ]; then
  watchdogPid=`cat ${CONF_DIR_TMP}/addressWatchDog.pid`
  kill -9 ${watchdogPid}
fi

echo $$ > ${pidfile}

while :
do
  arping -c 5 -D -q $1
  if [ $? -ne 0 ]; then
    #We detected someone else using our address
    break
  fi
  sleep 5
done

logmessage_warn "DUPLICATE IP \"$1\" detected - Interface deconfigured"
reason=DUPLICATEIP
echo "reason=${reason}" >${tmpDhcpParameters}
echo "old_ip_address=${old_ip_address}" >>${tmpDhcpParameters}

export old_ip_address=$1
export interface=$2
deconfigureIpv4Interface
logmessage_warn "IPv4 NETWORK DECONFIGURED (L3)"

logmessage "netcmd dhcpv4ConfChange -r ${reason} -f ${tmpDhcpParameters}"
netcmd dhcpv4ConfChange -r ${reason} -f ${tmpDhcpParameters}
rm -f ${pidfile}
